<?php 
class SubscriberMagnet {
    public $modx, $config;
    public static $request_key = 'kcEvgeniXjUpqj89Qmksdf';
    public static $cookie_name = 'qTy78SbecReLoc1';
    
    protected $_classname;
        
    public function __construct(modX &$modx, $config = array()){
        $this->modx =& $modx;
        $this->_classname = strtolower(get_class($this));
        
        $this->config = array_merge(array(
             'assets' => $this->modx->getOption('assets_url').'components/'.$this->_classname.'/'
            ,'path'   => $this->modx->getOption('core_path').'components/'.$this->_classname.'/'
        ), $config);
    }
    
    public function on(){
        $modx = & $this->modx;
        
        if($_COOKIE[self::$cookie_name]) return '';
                
        $ip = $this->getOption('run_ips');
        if(!empty($ip)){
            $ip = explode(',', $ip);
                
            if(!in_array($_SERVER['REMOTE_ADDR'], $ip)){
                return '';
            }
        }
     
        $ids = $this->getOption('pages');
        if(empty($ids)) return '';
        
        $ids = str_replace(' ','',$ids);
        $ids = explode(',', $ids);
        
        $id = $modx->resource->get('id');
        $parent = $modx->resource->get('parent');
        
        if(!in_array($parent, $ids) && !in_array($id, $ids)) return '';
          
        $url = $this->getOption('handler');
        $url = $modx->makeUrl($url, '', '', 'full') . '?wmodeframe';
        
        $frame = $modx->getChunk($this->config['tpl'], array('url' => $url));  
        return $frame;      
    }
    
    public function execute(){
        if(isset($_GET['wmodeframe'])){ // load frame-content
            $this->_load();
        }
        if(isset($_REQUEST[self::$request_key])){ // handler form
            $this->_handler();
        }  
        
        $this->_afterSubscribe(); 
    }

    public function getOption($key, $options = null, $default = null){
        $key = "{$this->_classname}.$key";
        return $this->modx->getOption($key, $options, $default);
    }    
        
    private function _load(){

      $style = $this->config['assets'] . 'styles/' .$this->getOption('style') .'/';
      $loading_img =  $style . 'preloader.gif';
      $style_ie .= $style . 'css_ie.css';
      $style    .= 'css.css';
      $open_disable = '';
      $home = $this->modx->getOption('site_url');
      
      $js = $this->config['assets'] . 'js/js.js';
      $jquery = $this->config['assets'] . 'js/jquery.js';
      
      if(!$this->getOption('run_ips')){
          $open_disable = "window.location.href = '$home';";  
      }
        
      $data = array(
              'charset'          => $this->modx->getOption('modx_charset') 
             ,'request_key'      => self::$request_key
             ,'title'            => $this->getOption('title')
             ,'description'      => $this->getOption('description')
             ,'description2'     => $this->getOption('description2')
             ,'titleSubcribeMe'  => $this->getOption('titleSubcribeMe')
             ,'action'           => $this->modx->makeUrl($this->getOption('handler'), '', '', 'full')
      );

      $data = array_merge(
          compact('style', 'style_ie', 'loading_img', 'open_disable', 'js', 'jquery'),
          $data  
      );
      
      $out = $this->modx->getChunk($this->config['tpl'], $data);
      exit($out);       
    }
    
    private function _handler(){
        if($_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest') exit();

        $key = $this->getOption('secret_key');
        $recoveryTemplate = $this->modx->getChunk($this->config['recovery.tpl'], array('secret_key' => $key));

        require_once $this->config['path'] . 'cls/cls.php';
        
        $service = SubsriberMagnetServiceApi::getService(
            $this->getOption('smart_api_id'), 
            $this->getOption('smart_api_pass'), 
            $this->getOption('smart_api_delivery_id'),
            $this->getOption('smart_api_service')
        ); 
        $service->after_subscribe_url =  $this->modx->makeUrl($this->getOption('handler'), '', '', 'full');   

        $handler = new SubsriberMagnetHandler($service, $_REQUEST, self::$cookie_name);   
        $handler->set('recoveryTemplate', $recoveryTemplate);
        $handler->set('secret_key', $key);   
        
        $handler->execute();         
    }
    
    private function _afterSubscribe(){
        
        if($_COOKIE[self::$cookie_name]){    // subscriber is
            exit(header('Location: '.$this->modx->getOption('site_url')));
        } 
        
        if(!isset($_COOKIE['plgSecretpageReturnPage'])) return;

        $returnPage = $_COOKIE['plgSecretpageReturnPage'].'/#enterCode';
        $returnPage = str_replace('//#', '/#', $returnPage);
        setcookie('plgSecretpageReturnPage', '', (time() - 6000), '/', $_SERVER['SERVER_NAME']);
        setcookie('plgSecretpageAction', 'enterCode', (time() + 600), '/', $_SERVER['SERVER_NAME']);
        
        exit(header('Location: '.$returnPage));  
    }    
    
}