<?php
// plgContentSubsribermagnet handler v 1.55
define('_JEXEC', 1);
define('DS', DIRECTORY_SEPARATOR);

define('JPATH_BASE', dirname(dirname(dirname(dirname(__FILE__)))));

require_once JPATH_BASE.'/includes/defines.php';
require_once JPATH_BASE.'/includes/framework.php';
require_once 'functions.php';

jimport('joomla.plugin.plugin');
jimport('joomla.plugin.helper');
jimport('joomla.application.component.helper');
jimport('joomla.version');

$mainframe = &JFactory::getApplication('site');
$mainframe->initialise();



class plgContentSubsribermagnetHandler{
    public static $CookieName   = 'qTy78SbecReLoc1';
    public static $RequestKey   = 'kcEvgeniXjUpqj89Qmksdf';
    public static $FormKey      = 'kcEvgeniXjU15pq07j1983';
        
    private $_type = 'content';
    private $_name = 'subscribermagnet';
    
    private  $_abs_assets, $_url_assets, $_home_url; // assets folder
    
    public $params;
	
    public function __construct(){
        // params
        $plugin = JPluginHelper::getPlugin($this->_type, $this->_name);
        $pluginParams = new JRegistry();
        $pluginParams->loadINI($plugin->params);
        $this->params = $pluginParams->toObject();
        $this->_set_assets();
	}    
    
    public function execute(){
        $ips = $this->params->run_ips;
        if(!empty($ips)){
            $ips = explode(',',$ips);
            $clientIp = SubMagnetFunctions::getClientIp();
            if(!in_array($clientIp['ip'], $ips)){
                exit('');  
            } 
        }        
        
        $this->_afterSubscribe();
        $this->_handlerForm();
      
        $this->_onLoadFrameForm();
           
        $this->_onFrame();
    }
    

    /**
     * @since 1.5
    */
    private function _afterSubscribe(){
        if($_COOKIE[self::$CookieName]) return; // subscriber is

        if(stripos($_SERVER['REQUEST_URI'], $this->params->signal_key) === false) return ; // return from subscribe service
        
        if(!$_COOKIE['plgSecretpageReturnPage']) return;

        $returnPage = $_COOKIE['plgSecretpageReturnPage'].'#enterCode';
        $returnPage = str_replace('/#', '#', $returnPage);
        
        setcookie('plgSecretpageReturnPage', '', (time() - 6000), '/', $_SERVER['SERVER_NAME']);
        setcookie('plgSecretpageAction', 'enterCode', (time() + 600), '/', $_SERVER['SERVER_NAME']);
        
        exit(header('Location: '.$returnPage));  
    }
    
    /**
     * @since 1.5
     * ADD ifarme
    */       
    private function _onFrame(){

        
        $url = JURI::base() . '/plugins/content/subscribermagnet/?wmodeframe=' . self::$RequestKey; 
        $js = file_get_contents($this->_abs_assets . 'ifr.tpl');
        $js = SubMagnetFunctions::parseTemplate(array('url' => $url), $js);
        $js = str_replace("<script type='text/javascript'>",'',$js);
        $js = str_replace('</script>','',$js);
                

        header("Content-Disposition: inline");  
        header("Content-Length: " . strlen($js));                        
        header("Content-Type: application/x-javascript");   
        
        if(isset($_COOKIE[self::$CookieName])) exit('var subsribermagnet_unlock = true;'); // subscriber is                
                
        exit($js);        
    }
    
    /**
     * @since 1.5
     * Загрузка окна во фрейме
    */
    private function _onLoadFrameForm(){
        if($_GET['wmodeframe'] != self::$RequestKey or isset($_COOKIE[self::$CookieName])) return '';
        
        $wrapper = file_get_contents($this->_abs_assets . 'wrapper.tpl');
        require_once $this->_abs_assets . 'cls/cls.php';
        
        $fields = array(
             'title'    => $this->params->title
            ,'form'     => $this->_getPluginHtml()
            ,'style'    => $this->_getPluginCss()
            ,'js'       => $this->_url_assets . 'js/js.js?v='.SubsriberMagnetServiceApi::VERSION
            ,'jquery'   => $this->_url_assets . 'js/jquery.js'
            ,'home'     => JURI::base(true)
            ,'goodalert'=> ''
        ); 
        
        $wrapper = SubMagnetFunctions::parseTemplate($fields, $wrapper);
        exit($wrapper);         
    }       
    
     private function _handlerForm(){
            if(!isset($_REQUEST[self::$RequestKey]) OR isset($_COOKIE[self::$CookieName])) return; 
            
            if($_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest') exit();
            
            require_once $this->_abs_assets . 'cls/cls.php';
            
            $service = SubsriberMagnetServiceApi::getService(
                $this->params->smart_api_id, 
                $this->params->smart_api_pass, 
                $this->params->smart_api_delivery_id,
                $this->params->smart_api_service
            );
            
             $service->after_subscribe_url =  JURI::base() . '/plugins/content/subscribermagnet/?'.$this->params->get('signal_key');
            
            $recoveryTemplate = str_replace('&#13;&#10;', "\n", $this->params->smart_api_recoveryTemplate);
            $recoveryTemplate = str_replace('{{secret_key}}',   $this->params->secret_key, $recoveryTemplate);
            
            $handler = new SubsriberMagnetHandler($service, $_REQUEST, self::$CookieName); 
            $handler->set('recoveryTemplate', $recoveryTemplate);
            $handler->set('secret_key', $this->params->secret_key);
            
            $handler->execute();        
        }    
    
    // add html-form-tpl
    private function _getPluginHtml(){
        
        // close url 
        $close_url = $this->params->close_url;
        if(!$close_url) $this->params->close_url = JURI::root();
          
        // get plugin-template
        $ptemplate = file_get_contents($this->_abs_assets . 'template.tpl'); 

        $this->params->request_key = self::$RequestKey;
        
        $params = (array) $this->params;
        $params['loading_img'] = $this->_url_assets . 'styles/' . $this->params->style . '/preloader.gif';
        $params['action'] = JURI::base() . '/plugins/content/subscribermagnet/';
        
        $ptemplate = SubMagnetFunctions::parseTemplate($params, $ptemplate);
       
        return $ptemplate;
    } 


    /**
     * @since 1.5
    */    
    private function _getPluginCss($returnString = true){
       $_style = $this->params->style;

       $style  = $this->_url_assets . 'styles/'.$_style.'/css.css';
       $ie   = $this->_url_assets . 'styles/'.$_style.'/css_ie.css';
       
       if(!$returnString){
           return compact('style','ie');  
       }
       
       $return = '<link rel="stylesheet" href="'. $style .'" />';
       $return .= '<!--[if lt IE 9]><link rel="stylesheet" href="'. $ie .'" /><![endif]-->';

       return $return;
         
    } 
        
 
    
    /**
     * @since 1.5
    */      
    protected function _set_assets(){
        JPluginHelper::importPlugin($this->_type, $this->_name, false);
        $assets = SubMagnetFunctions::get_assets($this->_type, $this->_name);

        $this->_abs_assets  = JPATH_BASE . '/' .$assets;
        $this->_plugun_home = JURI::base();
        $this->_url_assets  = $this->_plugun_home . $assets;
    }    
 

}

$plagin = new plgContentSubsribermagnetHandler();
$plagin->execute();
exit();